<?php

class dcReferers {

	function displayReferers($nb_refs = 5, $no_ref_text = 'Pas de r&eacute;f&eacute;renceurs pour l\'instant') {
		$referants = dirname(__FILE__) . '/reffichier.html';
		$blacklist = dirname(__FILE__) . '/refblacklist.html';

		if ( isset($_SERVER['HTTP_REFERER'])
				&& ($_SERVER['HTTP_REFERER'] != '')
				&& ($_SERVER['HTTP_REFERER'] != 'bookmarks') )
		{
			$ref_court = preg_replace("/(http|https|ftp|news):\/\//","", $_SERVER['HTTP_REFERER']);
			$ref_court = preg_replace("/\/.*/", "", $ref_court);

			if ( ($ref_court != $_SERVER['SERVER_NAME'])
					&& ($ref_court != 'bookmarks') && is_writable($referants) )
			{

				$ref_long = preg_replace("/&/", "&", $_SERVER['HTTP_REFERER']);

				$reffichier = fopen($referants,'a');
				fwrite($reffichier, "<li><a href=\"" . htmlentities($ref_long, ENT_NOQUOTES) . "\" rel=\"nofollow\">$ref_court</a></li>\n");
				fclose($reffichier);
			}
		}

		if (file_exists($referants))
		{
			$refarray = file($referants);
			$refreverse = array_reverse($refarray);
			$refunique = array_unique($refreverse);
			$refcount = count($refunique);
			$filter = false;

			if (file_exists($blacklist)) {
				$filter = true;
				$blarray = file($blacklist);
				$blcount = count($blarray);
			}

      $i = 0;
      $nb_filtered = 0;
      while ($i < $nb_refs)
      {
        if ($i + $nb_filtered > $refcount) { break; }
        if ($filter) {
          $url = array_shift($refunique);
          $matched = false;
          if (preg_match('!href="([^ ]+)"!', $url, $refs)) {
            for ($j = 0; $j < $blcount; $j++) {
              if ((trim($blarray[$j]) != '') and (preg_match('!' . trim($blarray[$j]) . '!i', $refs[1]))) {
                $nb_filtered = $nb_filtered + 1;
                $matched = true;
                break;
              }
            }
          }
          if (!$matched) {
            $refdisplay[] = $url;
            $i = $i + 1;
          }
        } else {
          $refdisplay[] = array_shift($refunique);
          $i = $i + 1;
        }
      }
			if (is_array($refdisplay) and count($refdisplay) > 0 and !((count($refdisplay) == 1) and (trim($refdisplay[0]) == ''))) {
				echo '<ul>';
				for ($i = 0; $i < count($refdisplay); $i++)
				{
					echo $refdisplay[$i];
				}
				echo '</ul>';
			} else if ($no_ref_text != '') {
				echo '<p>' . $no_ref_text . '</p>';
			}
		}

	}

}

?>
